#ifndef __LAUNCHERINPUT_H
#define __LAUNCHERINPUT_H

#define HAVE_LAUNCHER_INPUT 1
#define LAUNCHER_INPUT_SWITCH_BUTTON 1 // used by EngKeyboard only // TODO remove it from here

#ifdef HAVE_LAUNCHER_INPUT

#define INPUT_CONF_MAX_CHAR_PER_LINE 256
#define INPUT_CONF_MAX_FIELD 7
typedef struct {
	char* name;     // name
	char* title;    // title name of this input
	char* path;     // relative/absolute path and file name to this input application
	char* argument; // argument
	int   pid;      // process ID
	int   wid;      // Gr window ID
	int   pwid;     // parent Gr window ID
	unsigned char status;     // application running status
	unsigned char resize_app; // application window should be shrink when this input is activated
	char  deskmsgid;          // unique id (from deskmsg.h and nxdeskmsg.h)
} LauncherInput;

extern LauncherInput*
launcher_input_launcher_read_configuration_file( LauncherInput* launcherInput, unsigned char* num_launcher_input );
/* TODO read configuration file from inputs (i.e. soft keyboards, handwriting, etc)
extern void
launcher_input_input_read_configuration_file( char*          search_name,
                                              unsigned char* input_id,
                                              unsigned char* target1,
                                              unsigned char* target2,
                                              unsigned char* target3 );
*/

#endif HAVE_LAUNCHER_INPUT

#endif /* LAUNCHERINPUT_H */
